/******************************************************************************
 CEBSwitchboard.cp
 
					The Event Broadcasting Switchboard Class
		
		Event Broadcasting switchboard, uses a single global instance of a
		CEBCollaborator broadcast events to any object that needs it.
	
	SUPERCLASS = CSwitchboard
	
	Copyright  1992 Joe Zobkiw. All rights reserved.
    Portions Copyright  1990 Symantec Corporation.  All rights reserved.

	Copyright  1995 Gregory Bonk. All rights reserved.
		Changes upgrade to TPM 7.0.7
 ******************************************************************************/

#include "CEBSwitchboard.h"
#include "CEBCollaborator.h"

/*** Global Variables ***/
	
extern CDesktop			*gDesktop;			/* The visible Desktop */
extern CEBCollaborator	*gEBCollaborator;	/* event broadcaster */


/**** C O N S T R U C T I O N / D E S T R U C T I O N   M E T H O D S ****/

CEBSwitchboard::CEBSwitchboard(void) : CSwitchboard()
{

}


CEBSwitchboard::~CEBSwitchboard(void)
{

}


/******************************************************************************
 DispatchEvent

		Handle broadcasting all events except null events
 ******************************************************************************/
void	CEBSwitchboard::DispatchEvent(EventRecord *macEvent)
{
	gEBCollaborator->BroadcastEvent(macEvent);
	inherited::DispatchEvent(macEvent);
}


/******************************************************************************
 DoIdle

		Handle broadcasting null events here because they do not get routed 
		through DispatchEvent.
 ******************************************************************************/
void	CEBSwitchboard::DoIdle(EventRecord *macEvent)	/* Usually a null or system event	*/
{
	gEBCollaborator->BroadcastEvent(macEvent);
	inherited::DoIdle(macEvent);
}