/******************************************************************************
 x_CAboutBox.cp

				CAboutBox Dialog Director Class
	
	Copyright  1995 Gregory Bonk for NewMedia Inc.. All rights reserved.

	Generated by Visual Architect

	This file is rewritten each time you generate code. You should not
	make changes to this file; changes should go in the CAboutBox.cp
	file, instead.

	If you want to change how Visual Architect generates this file, you can
	change the template for this file. It is "_Dialog_cp" in the Visual Architect
	Templates folder.

 ******************************************************************************/

#include "x_CAboutBox.h"

#include "AboutBoxItems.h"

#include "ViewUtilities.h"

#include <CIntegerText.h>
#include <Commands.h>
#include <CControl.h>
#include <CPopupMenu.h>
#include <CPopupPane.h>
#include <CArrayPane.h>
#include <CIconButton.h>
#include <CPictureButton.h>
#include <CSwissArmyButton.h>

#include "CIconPane.h"
#include "CStaticText.h"
#include "CButton.h"


#include <CApplication.h>
#include <CBartender.h>
#include <Commands.h>
#include <Constants.h>
#include <CDecorator.h>
#include <CDesktop.h>
#include <CDirectorOwner.h>
#include <CFile.h>
#include <CList.h>
#include <CPanorama.h>
#include <TBUtilities.h>
#include <CWindow.h>

extern	CApplication *gApplication;		/* The application					*/
extern CDecorator	*gDecorator;		/* Decorator for arranging windows	*/
extern CDesktop		*gDesktop;			/* The visible Desktop				*/
extern CBartender	*gBartender;		/* Manages all menus				*/

	// Define symbols for commands handled by this class
	// Prevents a recompile every time any command changed.


TCL_DEFINE_CLASS_M1(x_CAboutBox, CDialogDirector);

/**** C O N S T R U C T I O N / D E S T R U C T I O N   M E T H O D S ****/


/******************************************************************************
 Ix_CAboutBox

	Initialize the dialog
 ******************************************************************************/

void x_CAboutBox::Ix_CAboutBox(CDirectorOwner *aSupervisor, Boolean push)

{
	IDialogDirector(aSupervisor);

		// There are several circumstances where we don't want
		// ProviderChanged to be called. During initialization,
		// during calls to UpdateData, etc. The ignore flag
		// heads these off.

	ignore = TRUE;						/* Don't call UpdateData now		*/

	MakeNewWindow();					/* Create the dialog's window		*/

	DoBeginData(push);					/* Gather initial values			*/

	ignore = FALSE;
}


/******************************************************************************
 MakeNewWindow

	Create a window by reading a view resource
 ******************************************************************************/

void x_CAboutBox::MakeNewWindow(void)

{
	itsWindow = TCLGetNamedWindow("\pAboutBox", this);

		// Initialize pointers to the subpanes in the window

  fAboutBox_Icon1 = (CIconPane*) FindPane(kAboutBox_Icon1ID);
  ASSERT(member(fAboutBox_Icon1, CIconPane));

  fAboutBox_Stat2 = (CStaticText*) FindPane(kAboutBox_Stat2ID);
  ASSERT(member(fAboutBox_Stat2, CStaticText));

  fAboutBox_Stat3 = (CStaticText*) FindPane(kAboutBox_Stat3ID);
  ASSERT(member(fAboutBox_Stat3, CStaticText));

  fAboutBox_Stat4 = (CStaticText*) FindPane(kAboutBox_Stat4ID);
  ASSERT(member(fAboutBox_Stat4, CStaticText));

  fAboutBox_Stat6 = (CStaticText*) FindPane(kAboutBox_Stat6ID);
  ASSERT(member(fAboutBox_Stat6, CStaticText));

  fAboutBox_Butn7 = (CButton*) FindPane(kAboutBox_Butn7ID);
  ASSERT(member(fAboutBox_Butn7, CButton));

  fAboutBox_Stat8 = (CStaticText*) FindPane(kAboutBox_Stat8ID);
  ASSERT(member(fAboutBox_Stat8, CStaticText));

  fAboutBox_Stat11 = (CStaticText*) FindPane(kAboutBox_Stat11ID);
  ASSERT(member(fAboutBox_Stat11, CStaticText));

}


/******************************************************************************
 FindPane

	Locate a subpane of this window by ID. Note that Visual Architect-
	generated IDs are unique within a project, so this function
	will find panes within subviews, even if dynamically loaded.
 ******************************************************************************/

CPane *x_CAboutBox::FindPane(long ID)

{
	return (CPane*) itsWindow->FindViewByID(ID);
}


/******************************************************************************
 DoBeginData
 
 	Collect initial values from subclass and initialize panes
******************************************************************************/

void x_CAboutBox::DoBeginData(Boolean push)

{
	CAboutBoxData		data = {0};		/* The initial value record			*/

	BeginData(&data);					// Ask subclass for initial values

	if (!push)
	{
		DispensePaneValues(data);		// Set panes
	}

		// Save the initial values in case user cancels

	saveData = data;
}


/******************************************************************************
 DoEndData
 
 	Collect final values from panes and tell subclass.
 	During EndData(), data argument has current values and
 	saveData has initial values. After EndData(), saveData
 	holds current values.
******************************************************************************/

void x_CAboutBox::DoEndData(long theCommand)

{
	CAboutBoxData		data;			/* The initial value record			*/
	RgnHandle			rgn;			/* Selection region					*/

										/* If user canceled the dialog,		*/
	if (theCommand == cmdCancel)		/*	 return the initial values		*/
	{
		data = saveData;
	}
	else
		CollectPaneValues(data);		// Get current pane values

	EndData(&data);						// Tell the derived class

	saveData = data;					// Now has current values
}


/******************************************************************************
 SetData
 
 	Set initial values of panes. Must be called after I-function. (2.0.5)
******************************************************************************/

void x_CAboutBox::SetData(const CAboutBoxData& initial)
{
	DispensePaneValues(initial);
	saveData = initial;
}


/******************************************************************************
 GetData
 
 	Collect final values from panes. Must be called after DoEndData
 	(which means it is usually only meaningful for modal dialogs,
 	as modeless dialogs usually call DoEndData during Close()). (2.0.5)
******************************************************************************/

void x_CAboutBox::GetData(CAboutBoxData& final)
{
	final = saveData;
}


/******************************************************************************
 DispensePaneValues
 
 	Set pane values from argument struct
******************************************************************************/

void x_CAboutBox::DispensePaneValues(const CAboutBoxData& data)

{
		// Initialize the panes based on the values supplied.
		// The ASSERT statements ensure that the generated
		// code is in synch with the view resource.

}

/******************************************************************************
 CollectPaneValues
 
 	Collect final values from panes and tell subclass
******************************************************************************/

void x_CAboutBox::CollectPaneValues(CAboutBoxData& data)

{
	RgnHandle			rgn;			/* Selection region					*/

										/* Collect values from panes		*/
}


/******************************************************************************
 BeginData
 
 	Collect initial values from subclass and initialize panes.
 	The default function does nothing.
******************************************************************************/

void x_CAboutBox::BeginData(CAboutBoxData *initial)

{
}


/******************************************************************************
 UpdateData
 
 	Tell subclass when panes change
******************************************************************************/

void x_CAboutBox::UpdateData(CAboutBoxUpdate *update, long itemNo)

{
}


/******************************************************************************
 EndData
 
 	Tell subclass the final values. For a canceled modal dialog,
 	these are the same as the initial values.
******************************************************************************/

void x_CAboutBox::EndData(CAboutBoxData *final)

{
}


/******************************************************************************
 DoModalDialog	{OVERRIDE}
 
 	Override to call EndData
******************************************************************************/

long x_CAboutBox::DoModalDialog(long defaultCmd)

{
	long	result = CDialogDirector::DoModalDialog(defaultCmd);
	
	DoEndData(result);
	return result;
}


/******************************************************************************
 Close {OVERRIDE}
 
 	Override to call EndData
******************************************************************************/

Boolean x_CAboutBox::Close(Boolean quitting)

{	
	if (itsWindow && !itsWindow->active)
		itsWindow->Select();

	if (EndDialog(cmdOK, TRUE))
	{										
										/* For a modal dialog, exit through	*/
		if (itsWindow->IsModal())		/*	 DoModalDialog					*/
		{
			dismissCmd = cmdClose;
			return TRUE;
		}
		else
		{
										/* Collect final values and call	*/
			DoEndData(cmdOK);			/*	 EndData						*/
										/* Do the Close, skipping			*/
										/*	 CDialogDirector (7.0.4)		*/
			return CDirector::Close(quitting);
		}
	}
	else
		return FALSE;
}


/******************************************************************************
 ProviderChanged	{OVERRIDE}
 	
 	User did something. Note that the TCL
 	does not currently report changes to plain CEditText items. 
******************************************************************************/

void x_CAboutBox::ProviderChanged(CCollaborator *aProvider, long reason, void* info)

{
	CAboutBoxUpdate	data;			/* The update value record			*/
	Str255	str;
	Boolean	saveIgnore = ignore;
	
	if (ignore)							/* Don't be a chatterbox			*/
		return;
	ignore = TRUE;
	
	TRY
	{
 		if (FALSE) {}
		else
			CDialogDirector::ProviderChanged(aProvider, reason, info);
	}
	CATCH
		ignore = saveIgnore;
	ENDTRY
	
	ignore = saveIgnore;				/* ProviderChanged() can't Close()!	*/
}


